typedef struct __pal {
	int r;
	int g;
	int b;
} pal;

pal NSFPalette[39] = {
 #include "palettes/nsfnew.h"
};
pal palettevseb[64] = {
#include "palettes/vseb.h"
};
pal palettevsslalom[64] = {
#include "palettes/vsslalom.h"
};
pal palettevsgoon[64] = {
#include "palettes/vsgoonies.h"
};

pal palettevsgrad[64] = {
#include "palettes/vsplatoon.h"
};

pal palettevscv[64] = {
#include "palettes/vscv.h"
};

pal palettevssmb[64] = {
#include "palettes/vssmb.h"
};

pal palettevsmar[64] = {
#include "palettes/vsmar.h"
};

pal unvpalette[6] = {
{ 0x00,0x00,0x00}, // Black
{ 0x3F,0x3F,0x34}, // White
{ 0x00,0x00,0x00}, // Black
{ 0x1d,0x1d,0x24}, // Greyish
{ 190>>2,0,0    }, // Redish
{ 51>>2,255>>2,51>>2}, // Bright green
};
pal paletten[64];
pal palette[64] = {

        { 0x1D, 0x1D, 0x1D }, /* Value 0 */
	{ 0x09, 0x06, 0x23 }, /* Value 1 */
	{ 0x00, 0x00, 0x2A }, /* Value 2 */
	{ 0x11, 0x00, 0x27 }, /* Value 3 */
	{ 0x23, 0x00, 0x1D }, /* Value 4 */
	{ 0x2A, 0x00, 0x04 }, /* Value 5 */
	{ 0x29, 0x00, 0x00 }, /* Value 6 */
	{ 0x1F, 0x02, 0x00 }, /* Value 7 */
	{ 0x10, 0x0B, 0x00 }, /* Value 8 */
	{ 0x00, 0x11, 0x00 }, /* Value 9 */
	{ 0x00, 0x14, 0x00 }, /* Value 10 */
	{ 0x00, 0x0F, 0x05 }, /* Value 11 */
	{ 0x06, 0x0F, 0x17 }, /* Value 12 */
	{ 0x00, 0x00, 0x00 }, /* Value 13 */
	{ 0x00, 0x00, 0x00 }, /* Value 14 */
	{ 0x00, 0x00, 0x00 }, /* Value 15 */
	{ 0x2F, 0x2F, 0x2F }, /* Value 16 */
	{ 0x00, 0x1C, 0x3B }, /* Value 17 */
	{ 0x08, 0x0E, 0x3B }, /* Value 18 */
	{ 0x20, 0x00, 0x3C }, /* Value 19 */
	{ 0x2F, 0x00, 0x2F }, /* Value 20 */
        { 0x39, 0x00, 0x16 }, /* Value 21 */
	{ 0x36, 0x0A, 0x00 }, /* Value 22 */
	{ 0x32, 0x13, 0x03 }, /* Value 23 */
	{ 0x22, 0x1C, 0x00 }, /* Value 24 */
	{ 0x00, 0x25, 0x00 }, /* Value 25 */
	{ 0x00, 0x2A, 0x00 }, /* Value 26 */
	{ 0x00, 0x24, 0x0E }, /* Value 27 */
	{ 0x00, 0x20, 0x22 }, /* Value 28 */
	{ 0x00, 0x00, 0x00 }, /* Value 29 */
	{ 0x00, 0x00, 0x00 }, /* Value 30 */
        { 0x00, 0x00, 0x00 }, /* Value 31 */
	{ 0x3F, 0x3F, 0x3F }, /* Value 32 */
	{ 0x0F, 0x2F, 0x3F }, /* Value 33 */
	{ 0x17, 0x25, 0x3F }, /* Value 34 */
	{ 0x10, 0x22, 0x3F }, /* Value 35 */
	{ 0x3D, 0x1E, 0x3F }, /* Value 36 */
        { 0x3F, 0x1D, 0x2D }, /* Value 37 */
        { 0x3F, 0x1D, 0x18 }, /* Value 38 */
        { 0x3F, 0x26, 0x0E }, /* Value 39 */
        { 0x3C, 0x2F, 0x0F }, /* Value 40 */
        { 0x20, 0x34, 0x04 }, /* Value 41 */
        { 0x13, 0x37, 0x12 }, /* Value 42 */
	{ 0x16, 0x3E, 0x26 }, /* Value 43 */
	{ 0x00, 0x3A, 0x36 }, /* Value 44 */
        { 0x1E, 0x1E, 0x1E }, /* Value 45 */
	{ 0x00, 0x00, 0x00 }, /* Value 46 */
	{ 0x00, 0x00, 0x00 }, /* Value 47 */
	{ 0x3F, 0x3F, 0x3F }, /* Value 48 */
	{ 0x2A, 0x39, 0x3F }, /* Value 49 */
	{ 0x31, 0x35, 0x3F }, /* Value 50 */
	{ 0x35, 0x32, 0x3F }, /* Value 51 */
	{ 0x3F, 0x31, 0x3F }, /* Value 52 */
	{ 0x3F, 0x31, 0x36 }, /* Value 53 */
	{ 0x3F, 0x2F, 0x2C }, /* Value 54 */
	{ 0x3F, 0x36, 0x2A }, /* Value 55 */
	{ 0x3F, 0x39, 0x28 }, /* Value 56 */
	{ 0x38, 0x3F, 0x28 }, /* Value 57 */
	{ 0x2A, 0x3C, 0x2F }, /* Value 58 */
	{ 0x2C, 0x3F, 0x33 }, /* Value 59 */
	{ 0x27, 0x3F, 0x3C }, /* Value 60 */
        { 0x31, 0x31, 0x31 }, /* Value 61 */
	{ 0x00, 0x00, 0x00 }, /* Value 62 */
	{ 0x00, 0x00, 0x00 }, /* Value 63 */
};
